# -*- coding: utf-8 -*-
"""
Created on Mon Jun 29 11:59:30 2020

@author: Angel Garcia Olaya PLG-UC3M
@version: 1.0
"""


class Carta:

    def __init__(self, palo: str, valor: str):
        self.palo = palo
        self.valor = valor

    @property
    def palo(self) -> str:
        return self.__palo

    @palo.setter
    def palo(self, palo: str):
        # Esto podría haber sido un atributo privado, pero como solo se usa
        # aquí, lo dejamos como variable local de este método
        palos = ('oros', 'espadas', 'bastos', 'copas')
        if palo in palos:
            self.__palo = palo
        else:
            self.__palo = 'oros'

    @property
    def valor(self) -> str:
        return self.__valor

    @valor.setter
    def valor(self, valor: str):
        if valor in range(1, 11):
            self.__valor = valor
        else:
            self.__valor = 1

    def __str__(self):
        # Esto también podría haber sido un atributo privado
        nombres = ('as', 'dos', 'tres', 'cuatro', 'cinco', 'seis', 'siete',
                   'sota', 'caballo', 'rey')
        nombre = nombres[self.valor - 1]
        return nombre + ' de ' + self.palo
