# -*- coding: utf-8 -*-
"""
Created on Mon Jun 29 12:20:46 2020

@author: Angel Garcia Olaya PLG-UC3M
@version: 1.0
"""
from jugador import Jugador
from carta import Carta
import random


class Juego:

    def __init__(self, repartir: str, jugadores: Jugador):
        self.repartir = repartir
        self.jugadores = jugadores
        self.mesa = []
        self.baraja = []
        # Creamos la baraja
        # Podríamos haber puesto esta variabee como atributo de carta
        # para no repetirla aquí
        palos = ('oros', 'espadas', 'bastos', 'copas')
        for i in palos:
            for j in range(10):
                carta = Carta(i, j + 1)
                self.baraja.append(carta)

    def barajar(self):
        for cambios in range(100):
            # Una carta al azar
            primera = random.randrange(len(self.baraja))
            # Otra
            segunda = random.randrange(len(self.baraja))
            # Mientras sean la misma carta seguimos buscando
            while (segunda == primera):
                segunda = random.randrange(len(self.baraja))
            aux = self.baraja[primera]
            self.baraja[primera] = self.baraja[segunda]
            self.baraja[segunda] = aux
            # También se puede hacer_
            # self.baraja[primera],self.baraja[segunda] =
            # self.baraja[segunda], self.baraja[primera]

    def reparte(self):
        for cartas in range(self.repartir):
            for jugador in self.jugadores:
                # Guardamos la carta
                carta = self.baraja[-1]
                # La quitamos de la baraja
                del(self.baraja[-1])
                # Se la ponemos al jugador
                jugador.cartas.append(carta)
                # Descomentar para ver el reparto
                # print(str(carta) + ' para ' + jugador.nombre)

    def __posicion(self, valor: int) -> int:
        ''' Método auxiliar que imita al index '''
        # Devuelve la posición de ese valor dentro de la lista de valores de
        # las cartas
        valores = (1, 3, 10, 9, 8, 7, 6, 5, 4, 2)
        for i in range(len(valores)):
            if valor == valores[i]:
                return i

    def mayor_valor(self):
        # El palo que pinta es el de la primera y esa es la mayor al principio
        palo = self.mesa[0].palo
        mayor = self.mesa[0].valor
        pos = 0
        for carta in range(1, len(self.mesa)):
            # Solo puede ser mayor que la primera si es del mismo palo
            if (self.mesa[carta].palo == palo and
                self.__posicion(self.mesa[carta].valor) < self.__posicion(mayor)):
                mayor = self.mesa[carta].valor
                pos = carta
        return pos

    def jugar_mano(self):
        self.mesa = []
        for jugador in self.jugadores:
            carta = jugador.jugar()
            self.mesa.append(carta)
            print(jugador.nombre + ' juega el ' + str(carta))
        ganador = self.mayor_valor()
        print(self.jugadores[ganador].nombre + ' es el ganador')
        self.jugadores[ganador].puntuacion += 10


# Programa pincipal, debería ir en otra clase
jugador1 = Jugador('Pepe')
jugador2 = Jugador('Luis')
jugador3 = Jugador('Maria')
jugador4 = Jugador('Ana')
juego = Juego(4, (jugador1, jugador2, jugador3, jugador4))
juego.barajar()
# Descomentar para ver cómo ha quedado la baraja
# for carta in juego.baraja:
#    print(carta)
juego.reparte()
for mano in range(4):
    print('Mano: ' + str(mano + 1))
    juego.jugar_mano()
print('Resultados finales')
for jugador in juego.jugadores:
    print(jugador)
